// generated by CommonCode.cmake, do not edit.

/**
 * @file dc/version.h
 * Defines version macros and class for DisplayCluster.
 */

#ifndef DISPLAYCLUSTER_VERSION_H
#define DISPLAYCLUSTER_VERSION_H

#include <dc/api.h>
#include <string>

namespace dc
{
    /** The current major version. */
#   define DC_VERSION_MAJOR 0

    /** The current minor version. */
#   define DC_VERSION_MINOR 4

    /** The current patch level. */
#   define DC_VERSION_PATCH 0

    /** The current SCM revision. */
#   define DC_VERSION_REVISION 0x0

    /** The current binary interface. */
#   define DC_VERSION_ABI 0

/** True if the current version is newer than the given one. */
#   define DC_VERSION_GT( MAJOR, MINOR, PATCH )       \
    ( (DC_VERSION_MAJOR>MAJOR) ||                     \
      (DC_VERSION_MAJOR==MAJOR && (DC_VERSION_MINOR>MINOR || \
          (DC_VERSION_MINOR==MINOR && DC_VERSION_PATCH>PATCH))))

/** True if the current version is equal or newer to the given. */
#   define DC_VERSION_GE( MAJOR, MINOR, PATCH )       \
    ( (DC_VERSION_MAJOR>MAJOR) ||                     \
      (DC_VERSION_MAJOR==MAJOR && (DC_VERSION_MINOR>MINOR || \
          (DC_VERSION_MINOR==MINOR && DC_VERSION_PATCH>=PATCH))))

/** True if the current version is older than the given one. */
#   define DC_VERSION_LT( MAJOR, MINOR, PATCH )       \
    ( (DC_VERSION_MAJOR<MAJOR) ||                     \
      (DC_VERSION_MAJOR==MAJOR && (DC_VERSION_MINOR<MINOR || \
          (DC_VERSION_MINOR==MINOR && DC_VERSION_PATCH<PATCH))))

/** True if the current version is older or equal to the given. */
#   define DC_VERSION_LE( MAJOR, MINOR, PATCH )       \
    ( (DC_VERSION_MAJOR<MAJOR) ||                     \
      (DC_VERSION_MAJOR==MAJOR && (DC_VERSION_MINOR<MINOR || \
        (DC_VERSION_MINOR==MINOR && DC_VERSION_PATCH<=PATCH))))

/** Information about the current DisplayCluster version. */
class DC_API Version
{
public:
    /** @return the current major version of DisplayCluster. */
    static int getMajor();

    /** @return the current minor version of DisplayCluster. */
    static int getMinor();

    /** @return the current patch level of DisplayCluster. */
    static int getPatch();

    /** @return the current DisplayCluster version (MM.mm.pp). */
    static std::string getString();

    /** @return the SCM revision. */
    static int getRevision();

    /** @return the current binary interface version of DisplayCluster. */
    static int getABI();

    /** @return the current DisplayCluster version plus the git SHA hash (MM.mm.pp.rev). */
    static std::string getRevString();

    /**
     * Runtime check for ABI compatibility.
     *
     * Call from code using DisplayCluster. Will fail if the executable
     * was compiled against a version incompatible with the runtime version.
     *
     * @return true if the link-time and compile-time DSO are compatible.
     */
    static bool check()
    {
        return getMajor()==DC_VERSION_MAJOR &&
               getMinor()==DC_VERSION_MINOR;
    }
};

}

#endif
