

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was DisplayClusterConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

####################################################################################

set(DisplayCluster_PREFIX_DIR ${PACKAGE_PREFIX_DIR})
if(CMAKE_VERSION VERSION_LESS 2.8.3) # WAR bug
  get_filename_component(CMAKE_CURRENT_LIST_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
endif()
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})
# Copyright (c) 2014 Stefan.Eilemann@epfl.ch

# Provides common_package(Name args) which improves find_package.
# First invokes find_package with all the given arguments, and then
# falls back to using pkg_config if available. The pkg_config path
# does only implement the version, REQUIRED and QUIET find_package
# arguments (e.g. no COMPONENTS)

find_package(PkgConfig)
set(ENV{PKG_CONFIG_PATH}
  "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")

macro(COMMON_PACKAGE Name)
  string(TOUPPER ${Name} COMMON_PACKAGE_NAME)
  set(COMMON_PACKAGE_ARGS ${ARGN}) # ARGN is not a list. make one.
  set(COMMON_PACKAGE_VERSION)

  if(COMMON_PACKAGE_ARGS)
    list(GET COMMON_PACKAGE_ARGS 0 COMMON_PACKAGE_VERSION)
    if(COMMON_PACKAGE_VERSION MATCHES "^[0-9.]+$") # is a version
      set(COMMON_PACKAGE_VERSION ">=${COMMON_PACKAGE_VERSION}")
    else()
      set(COMMON_PACKAGE_VERSION)
    endif()
  endif()

  list(FIND COMMON_PACKAGE_ARGS "QUIET" COMMON_PACKAGE_QUIET_POS)
  if(COMMON_PACKAGE_QUIET_POS EQUAL -1)
    set(COMMON_PACKAGE_QUIET)
  else()
    set(COMMON_PACKAGE_QUIET "QUIET")
  endif()

  list(FIND COMMON_PACKAGE_ARGS "REQUIRED" COMMON_PACKAGE_REQUIRED_POS)
  if(COMMON_PACKAGE_REQUIRED_POS EQUAL -1) # Optional find
    find_package(${Name} ${COMMON_PACKAGE_ARGS}) # try standard cmake way
    if((NOT ${Name}_FOUND) AND (NOT ${COMMON_PACKAGE_NAME}_FOUND) AND PKG_CONFIG_EXECUTABLE)
      pkg_check_modules(${Name} ${Name}${COMMON_PACKAGE_VERSION}
        ${COMMON_PACKAGE_QUIET}) # try pkg_config way
    endif()
  else() # required find
    list(REMOVE_AT COMMON_PACKAGE_ARGS ${COMMON_PACKAGE_REQUIRED_POS})
    find_package(${Name} ${COMMON_PACKAGE_ARGS}) # try standard cmake way
    if((NOT ${Name}_FOUND) AND (NOT ${COMMON_PACKAGE_NAME}_FOUND) AND PKG_CONFIG_EXECUTABLE)
      pkg_check_modules(${Name} REQUIRED ${Name}${COMMON_PACKAGE_VERSION}
        ${COMMON_PACKAGE_QUIET}) # try pkg_config way (and fail if needed)
    endif()
  endif()
endmacro()

set(_req)
set(_quiet)
set(DisplayCluster_fail)
set(DISPLAYCLUSTER_COMPONENTS)
if(NOT DISPLAYCLUSTER_FOUND)
  set(DISPLAYCLUSTER_STATUS ON)
else()
  set(DISPLAYCLUSTER_STATUS)
endif()

if(DisplayCluster_FIND_REQUIRED)
  set(_req REQUIRED)
endif()
if(DisplayCluster_FIND_QUIETLY)
  set(_quiet QUIET)
endif()

set(DISPLAYCLUSTER_FIND_FILES )
set(_output_type)
set(_out)
if(DisplayCluster_FIND_REQUIRED)
  set(_output_type FATAL_ERROR)
  set(_out 1)
else()
  set(_output_type STATUS)
  if(NOT DisplayCluster_FIND_QUIETLY)
    set(_out 1)
  endif()
endif()
if(NOT DisplayCluster_fail)
  list(APPEND DISPLAYCLUSTER_INCLUDE_DIRS ${DisplayCluster_PREFIX_DIR}/include)
  set(DISPLAYCLUSTER_DEB_DEPENDENCIES "displaycluster0 (>= 0.4)")
  set(DISPLAYCLUSTER_DEB_LIB_DEPENDENCY "displaycluster0-lib (>= 0.4)")
  set(DISPLAYCLUSTER_DEB_DEV_DEPENDENCY "displaycluster0-dev (>= 0.4)")

  if(DisplayCluster_FIND_COMPONENTS)
    find_library(${UPPER_PROJECT_NAME}_LIBRARY DisplayCluster NO_DEFAULT_PATH
                 PATHS ${DisplayCluster_PREFIX_DIR} PATH_SUFFIXES lib )
    list(APPEND DISPLAYCLUSTER_LIBRARIES ${DISPLAYCLUSTER_LIBRARY})
    foreach(_component ${DisplayCluster_FIND_COMPONENTS})
      find_library(${_component}_libraryname DisplayCluster_${_component} NO_DEFAULT_PATH
        PATHS ${DisplayCluster_PREFIX_DIR} PATH_SUFFIXES lib )

      if(${_component}_libraryname MATCHES "${_component}_libraryname-NOTFOUND")
        if(DisplayCluster_FIND_REQUIRED_${_component})
          set(DisplayCluster_fail "Component ${_component} ")
          message(FATAL_ERROR "   DisplayCluster_${_component} "
            "not found in ${DisplayCluster_PREFIX_DIR}/lib")
        elseif(NOT _quiet)
          message(STATUS "   DisplayCluster_${_component} "
            "not found in ${DisplayCluster_PREFIX_DIR}/lib")
        endif()
      else()
        string(TOUPPER ${_component} _COMPONENT)
        set(DISPLAYCLUSTER_${_COMPONENT}_FOUND TRUE)
        set(DISPLAYCLUSTER_${_COMPONENT}_LIBRARY ${${_component}_libraryname})
        list(APPEND DISPLAYCLUSTER_LIBRARIES ${${_component}_libraryname})
        list(APPEND DISPLAYCLUSTER_COMPONENTS ${_component})
      endif()
    endforeach()
  elseif(DISPLAYCLUSTER_FIND_FILES)
    find_file(DISPLAYCLUSTER_FILE NAMES  NO_DEFAULT_PATH
              PATHS ${DisplayCluster_PREFIX_DIR} PATH_SUFFIXES include)
    if(DISPLAYCLUSTER_FILE MATCHES "DISPLAYCLUSTER_FILE-NOTFOUND")
      set(DisplayCluster_fail " ")
      if(_out)
        message(${_output_type} "   Missing the DisplayCluster "
          "file in ${DisplayCluster_PREFIX_DIR}/include.")
      endif()
    endif()
  else()
    set(DISPLAYCLUSTER_LIBRARY_NAMES "dccore;dcwebservice;dcstream")
    foreach(_libraryname ${DISPLAYCLUSTER_LIBRARY_NAMES})
      string(TOUPPER ${_libraryname} _LIBRARYNAME)
      find_library(${_LIBRARYNAME}_LIBRARY ${_libraryname} NO_DEFAULT_PATH
                   PATHS ${DisplayCluster_PREFIX_DIR} PATH_SUFFIXES lib )
      if(${_LIBRARYNAME}_LIBRARY MATCHES "${_LIBRARYNAME}_LIBRARY-NOTFOUND")
        set(DisplayCluster_fail "${_libraryname} ")
        if(_out)
          message(${_output_type}
            "   Missing ${_libraryname} in ${DisplayCluster_PREFIX_DIR}/lib")
        endif()
      else()
        list(APPEND DISPLAYCLUSTER_LIBRARIES ${${_LIBRARYNAME}_LIBRARY})
        string(REPLACE "DisplayCluster_" "" _component ${_libraryname})
        string(TOUPPER ${_component} _COMPONENT)
        set(DISPLAYCLUSTER_${_COMPONENT}_FOUND TRUE)
        list(APPEND DISPLAYCLUSTER_COMPONENTS ${_component})
      endif()
    endforeach()
  endif()

  if(EXISTS ${DisplayCluster_PREFIX_DIR}/share/DisplayCluster/CMake/options.cmake)
    include(${DisplayCluster_PREFIX_DIR}/share/DisplayCluster/CMake/options.cmake)
  endif()
endif()

list(APPEND DISPLAYCLUSTER_LIBRARIES ${DISPLAYCLUSTER_DEP_LIBRARIES})
set(DISPLAYCLUSTER_DEP_LIBRARIES)
if(DisplayCluster_fail)
  set(DISPLAYCLUSTER_FOUND)
  set(DisplayCluster_FOUND)
  set(DISPLAYCLUSTER_VERSION)
  set(DISPLAYCLUSTER_VERSION_ABI)
  set(DISPLAYCLUSTER_INCLUDE_DIRS)
  set(DISPLAYCLUSTER_LIBRARIES)
  set(DISPLAYCLUSTER_DEB_DEPENDENCIES)
  set(DISPLAYCLUSTER_LIBRARY)
  set(DISPLAYCLUSTER_COMPONENTS)
  if(_out)
    message(STATUS "Could not find DisplayCluster: ${DisplayCluster_fail} not found")
  endif()
else()
  set(DISPLAYCLUSTER_FOUND TRUE)
  set(DisplayCluster_FOUND TRUE)
  set(DISPLAYCLUSTER_VERSION 0.4.0)
  set(DISPLAYCLUSTER_VERSION_ABI 0)
  set(DISPLAYCLUSTER_MODULE_FILENAME )
  list(SORT DISPLAYCLUSTER_INCLUDE_DIRS)
  list(REMOVE_DUPLICATES DISPLAYCLUSTER_INCLUDE_DIRS)
  if(DISPLAYCLUSTER_LIBRARIES)
    list(REMOVE_DUPLICATES DISPLAYCLUSTER_LIBRARIES)
  endif()
  if(_out AND DISPLAYCLUSTER_STATUS)
    message(STATUS "Found DisplayCluster 0.4.0-0 [${DISPLAYCLUSTER_COMPONENTS}] in "
      "${DISPLAYCLUSTER_INCLUDE_DIRS}:${DISPLAYCLUSTER_LIBRARY}")
  endif()
endif()
